#include "hw_impl_zybo.h"

struct PWMInputDriverState {
  int *channels[6];
};

int zybo_pwm_input_reset(struct PWMInputDriver *self) {
  if (self->state == NULL) {
    self->state = malloc(sizeof(struct PWMInputDriverState));
    if (self->state == NULL) {
      return -1;
    }
  }

  // Save the addresses of the input PWM recorders
  struct PWMInputDriverState *state = self->state;
  state->channels[0] = (int *) XPAR_PWM_RECORDER_0_BASEADDR;
  state->channels[1] = (int *) XPAR_PWM_RECORDER_1_BASEADDR;
  state->channels[2] = (int *) XPAR_PWM_RECORDER_2_BASEADDR;
  state->channels[3] = (int *) XPAR_PWM_RECORDER_3_BASEADDR;
  state->channels[4] = (int *) XPAR_PWM_RECORDER_4_BASEADDR;
  state->channels[5] = (int *) XPAR_PWM_RECORDER_5_BASEADDR;
  return 0;
}

int zybo_pwm_input_read(struct PWMInputDriver *self,
                        unsigned int channel,
                        unsigned long *pulse_width_us) {
  struct PWMInputDriverState *state = self->state;
  *pulse_width_us = (long) *((int *) state->channels[channel]);
  return 0;
}
